#!/usr/bin/env node
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@dojo/shim/global", "../lib/node/util", "../lib/common/util", "../index"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var global_1 = require("@dojo/shim/global");
    var util_1 = require("../lib/node/util");
    var util_2 = require("../lib/common/util");
    var index_1 = require("../index");
    util_1.getConfig()
        .then(function (config) {
        if (config.showConfigs) {
            console.log(util_2.getConfigDescription(config));
        }
        else {
            index_1.default.configure({ reporters: 'runner' });
            index_1.default.configure(config);
            return index_1.default.run();
        }
    })
        .catch(function (error) {
        if (!error.reported) {
            try {
                console.error(index_1.default.formatError(error));
            }
            catch (e) {
                console.error(error);
            }
        }
        global_1.default.process.exitCode = 1;
    });
});
//# sourceMappingURL=intern.js.map